package Matrixoriginal;
/*
 * Methoden: 
 * Einlesen und kopieren der Hauptmatrix
 * Ausgabe der Ergebnismatrix
 * Addition zweier Matrizen
 * Multiplikation zweier Matrizen (Es koennen auch nxm mit mxp-Matrizen 
 * miteinander multipliziert werden.)
 * Berechnung obere Dreiecksmatrix
 * Multiplikation mit einem Faktor
 * Spaltensumme
 * Zeilensumme
 * Berechnung der Spur (Summe der Diagonalelemente)
 */

public class Matrix {				//Deklaration der Klasse Matrix
// Variablendeklaration
	private double[][] matrix;
	
	public Matrix(double[][] matrix) {
		setMatrix(matrix);
	}// Konstruktor Matrix
	
// Einlesen und kopieren der Hauptmatrix	
	public void setMatrix(double[][] matrix) {
		double[][] matrixcopy = new double[matrix.length][matrix[0].length];
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				matrixcopy[i][j] = matrix[i][j];
			}// for j
		}// for i
		this.matrix = matrixcopy;
	}// setMatrix

// Ausgabe der Ergebnismatrix
	public String getMatrixAsString() {
		String r = "";
		for (int i = 0; i < matrix.length; i++) {
			for (int j = 0; j < matrix[i].length; j++) {
				r += matrix[i][j] + "\t";
			}// for j
			r += "\n";
		}// for i
		return r;
	}
	
	public String toString(){
		return matrix.length+" x "+matrix[0].length+"-Matrix";
	}

// Addition zweier Matrizen	
	public void addMatrix(Matrix m2) {
		if ((matrix.length == m2.matrix.length)
				&& (matrix[0].length == m2.matrix[0].length)) {
			for (int i = 0; i < matrix.length; i++) {
				for (int j = 0; j < matrix[0].length; j++) {
					matrix[i][j]+= m2.matrix[i][j];
				}// for j
			}// for i
			return;
		}// if
		throw new MatrixException("Ungleiche Dimension");
	}// addMatrix
	
// Multiplikation zweier Matrizen (Es koennen auch nxm mit mxp-Matrizen 
// miteinander multipliziert werden.)
	public void multMatrix(Matrix m){
		double [][] mz = new double [matrix.length][m.matrix[0].length];
		double z,x;
		if (matrix[0].length == m.matrix.length){
			for (int i=0; i< matrix.length; i++){
				for (int j=0; j< m.matrix[0].length; j++){
					x=0;
					for (int k=0; k<m.matrix.length;k++){
					z = matrix[i][k] * m.matrix[k][j];
					x += z;
					}// for k
					mz[i][j]=x;
				}// for j
			}// for i
			this.matrix=mz;
			return;
		}//if
		throw new MatrixException ("Die Matrizen knnen nicht " +
				"multipliziert werden (keine nxm mxp Matrizen)");
	}// multMatrix
	
// Berechnung obere Dreiecksmatrix	
	public Matrix odreiecksMatrix(){
		double z;
		double [] temp;
//		Abfrage ob Matrix quadratisch
		if (matrix[0].length == matrix.length){
//			 Die Zeilen der Matrix werden durchlaufen, bis auf die auf die
//			 letzte Zeile
			for (int i=0; i<matrix.length-1; i++){	  
//				 berprfung ob Hauptdiagonale eine 0 enthlt, falls ja,													 
				if (matrix[i][i]==0e-10){	 
//					wird nach einer Zeile gesucht die in dieser Spalte 
//					keine 0 hat.
					for (int j=i+1; j< matrix.length; j++){	  
//						Ist es so,so wird diese Zeile mit der ersten getauscht.			 
						if (matrix[j][i]!=0e-10){	  
							temp=matrix[j];		  
							matrix[j]=matrix[i];
							matrix[i]=temp; 
//							 Abbruchbedingung fr die For-Schleife
							j=matrix.length; 	 
						}// if
//						Sollte die gesamte Spalte 0 sein, ist die Matrix nicht
//						eindeutig lsbar.
						else if((j+1)== matrix.length){
							throw new MatrixException("Die Matrix ist nicht eindeutig lsbar!");
						}// else
					}// for j
				}// if  Diese Abfrage mu fr jede Untermatrix ausgefhrt werden
				for (int j=i+1; j<matrix[0].length;j++){
					z=matrix[j][i];
					for(int k=i;k<matrix.length;k++){
						matrix[j][k]=matrix[j][k]-(matrix[i][k]/matrix[i][i])*z;
					}//for k
				}// for j
			}// for i
			return this;
		}//if
		throw new MatrixException ("Dies ist keine quadratische Matrix!");
	}// odreiecksMatrix
	
// Multiplikation mit einem Faktor	
	public Matrix faktmultMatrix(double fakt){
		for (int i=0; i < matrix.length; i++){
			for (int j=0; j<matrix[i].length; j++){
				matrix[i][j] = matrix[i][j]* fakt;
			}// for j
		}// for i
		return this;
	}// faktmultMatrix

// Spaltensumme 	
	public double [] spSumme(){
	double [] summe;
	summe = new double[matrix[0].length];
		for (int i=0; i < matrix.length; i++){
			for (int j=0; j<matrix[0].length; j++){
				summe[j] += matrix[i][j];
			}// for i
		}// for j
		return summe;
	}// spSumme
	
// Zeilensumme	
	public double [] zSumme(){
		double [] summe;
		summe = new double[matrix.length];
		for(int i=0; i<matrix[0].length; i++){
			for (int j=0; j< matrix.length;j++){
				summe[j] += matrix[j][i];
			}//for i
		}// for j
		return summe;
	}// zSumme
	
// Berechnung der Spur (Summe der Diagonalelemente)	
	public double Spur(){
		double summe=0.0;
		if (matrix[0].length == matrix.length){
			for (int i=0; i<matrix.length;i++){
			summe += matrix[i][i];	
			}// for
			return summe;
		} //if
		throw new MatrixException ("Dies ist keine quadratische Matrix,\n " +
				"die Summe der Hauptdiagonalen kann daher nicht berechnet werden!") ;
	}// Spur
	
}//class matrix
